#ifndef __PROTOCOL_H__
#define __PROTOCOL_H__
//Requests

#define SWORDFISH_FINISH      1

/** 
 * send: [2][][][][][consumetime]
 * recv: [2][size] */
#define SWORDFISH_SIZE        2

/**
 * send: [3][][][][][consumetime]
 * recv: [3][rank] */
#define SWORDFISH_RANK        3

/**
 * send: [4][][][][][consumetime]
 * recv: [4]{unsigned long long with the time, 8 byte} */
#define SWORDFISH_TIME        4

/**
 * send: [5][time][][][][consumetime]
 * recv: [5] */
#define SWORDFISH_CONSUMETIME 5

/** 
 * send: [6][dest][tag][size][][consumetime]
 * send: data(size bytes)
 * recv: [6][result] */
#define SWORDFISH_SEND        6

/**
 * send: [7][length of receive buffer][][][][consumetime]
 * recv: [7][from][tag][size]
 * recv: data(size bytes) */
#define SWORDFISH_RECV        7

#define SWORDFISH_RECVFROM    8
#define SWORDFISH_RECVTAG     9

/**
 * send: [10][][][][][consumetime]
 * recv: [10][from][tag][size][errcode] */
#define SWORDFISH_PROBE       10

/**
 * send: [11][from][][][][consumetime]
 * recv: [11][from][tag][size][errcode] */
#define SWORDFISH_PROBEFROM   11

/**
 * send: [12][tag][][][][consumetime]
 * recv: [12][from][tag][size][errcode] */
#define SWORDFISH_PROBETAG    12

struct DataMessage {
  unsigned int request;
  unsigned int param1;
  unsigned int param2;
  unsigned int param3;
  unsigned int param4;
  unsigned int consumetime;
};


#endif /* __PROTOCOL_H__ */


