/** Christian Leber <christian@leber.de>
 */
/*
 * 0->1->-2->...n->0  and that for times
 * after this each node sends itself something */

#include "swf_client.c"
int num_clients=16;
int msg_size=16000;
int num_rounds=10;

void *main_thread(void *arg)
{
	int i,j, next;
	char *buf1,*buf2;	
	unsigned int from,tag,size;
	swf_conn con;
	
	con.fd = Tcpstuff_Get_Socket("localhost","17823");
	
	con.rank = 99999;
	/* first we have to tell swordfish our rank */
	write(con.fd,&con.rank,4);
	swfcom_get_rank(&con);
	swfcom_get_size(&con);
	printf("[%u][%us] size: %u\n", con.rank, time(NULL)-stime_, con.network_size);	
	buf1=(char *)malloc(msg_size);
	buf2=(char *)malloc(msg_size);
	
	for(j=0;j<=num_rounds;j++) {   //TODO try with j<=0 should also work...
	next=(con.rank+1)%num_clients;
	printf("[%u][%us] rank=%u\n",con.rank, time(NULL)-stime_,con.rank);
	if(con.rank==0) {
		for(i=0;i<msg_size;i++) {
			buf1[i] = (i*2) % 100;
			buf2[i] = 0;
		}
		swfcom_consumetime(&con,1000);

		if(swfcom_send(&con,next,43,msg_size,buf1) != 0)
			printf("error\n");
		printf("[%u][%us] sending to %u finished\n",con.rank, time(NULL)-stime_,next);
		swfcom_recv(&con,&from,&tag,&size,buf2,msg_size);
		printf("[%u][%us]received from %d, tag %d, size %d\n",
				con.rank,time(NULL)-stime_,from,tag,size);
		if(memcmp(buf1,buf2,msg_size)==0) {
			printf("\n[%u][%us]first test: SUCCESS! (j=%i)\n\n",con.rank, time(NULL)-stime_,j);
		} else {
			printf("\nERROR!\n");
			exit(1);
		}
		swfcom_consumetime(&con,500); //FIXME
	}
	else {
		swfcom_consumetime(&con,200); //FIXME
		printf("[%u][%us] going to recv...\n",con.rank, time(NULL)-stime_);
		swfcom_recv(&con,&from,&tag,&size,buf1,msg_size);
		printf("[%u][%us] received from %d, tag %d, size %d\n",
				con.rank,time(NULL)-stime_,from,tag,size);
		if(swfcom_send(&con,next,43,msg_size,buf1) != 0)
			printf("[%u] error\n",con.rank);
		printf("[%u][%us] SENDED TO: %u finished\n",con.rank, time(NULL)-stime_,next);
		swfcom_consumetime(&con,500); //FIXME
		printf("[%u][%us] consumetime finished\n",con.rank, time(NULL)-stime_);
	}
	}
	//FIXME
	swfcom_finish(&con);
	exit(0);


	printf("\n -- testing sending yourself something\n");
	
	for(i=0;i<msg_size;i++) buf1[i]=(i*2) % 100;
	for(i=0;i<msg_size;i++) buf2[i]=0;
	swfcom_consumetime(&con,10000);
	if(swfcom_send(&con,con.rank,43,4,buf1) != 0) printf("error\n");
	swfcom_consumetime(&con,10000);

	swfcom_recv(&con,&from,&tag,&size,buf2,4);
	swfcom_consumetime(&con,500); //FIXME

	printf("[%u] received from %d, tag %d, size %d\n",con.rank,from,tag,size);
	if(memcmp(buf1,buf2,4)==0)
		printf("\n2nd test: SUCCESS!\n");
	else
		printf("\nERROR!\n");
		
	printf("[%u][%us] going to disconnect\n",con.rank, time(NULL)-stime_);
	swfcom_finish(&con);
	printf("[%u][%us] disconnected\n",con.rank, time(NULL)-stime_);
}

int main(int argc, char **argv)
{
	int i;
	stime_=time(NULL);
	pthread_t thread[64];
	
	if(argc!=4) {
		printf("Usage: test01 <number of clients> <msg size> <number of rounds>\n");
		printf("<number of clients>  has to be between 2 and 64\n");
		exit(1);
	}
	num_clients = atoi(argv[1]);
	if(num_clients < 2 || num_clients > 64) {
		printf("<number of clients>  has to be between 2 and 64\n");
		exit(1);
	}
	printf("Number of clients: %i\n",num_clients);
	msg_size = atoi(argv[2]);
	printf("Message site: %i\n",msg_size);
	num_rounds= atoi(argv[3]);
	printf("Number of rounds: %i\n",num_rounds);

	printf("try to start for %i clients\n",num_clients);
	for (i=0;i<num_clients;i++) {
		pthread_create(&(thread[i]),0,main_thread,(void*)i);
	}
	printf("all started!\n");
	for (i=0;i<num_clients;i++) {
		pthread_join(thread[i],0);
	}
	printf("all ended\n");
	exit(0);
}

